/* lite.h
 *
 * $Id: deft.h,v 1.1 2007/09/08 07:26:33 costa Exp $
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@xplico.org>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __LITE_H__
#define __LITE_H__

#include "ftypes.h"


/* sqlite */
#define XS_DB_INSTALL_DIR  "/opt"
#define XS_DB_FILE         XS_DB_INSTALL_DIR"/xplico/xplico.db" /* DB file path */
#define XS_DIR_PATH        XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d"
#define XS_MAIL_DIR_PATH   XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/mail"
#define XS_HTTP_DIR_PATH   XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/http"
#define XS_FILE_DIR_PATH   XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/file"
#define XS_SIP_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/sip"
#define XS_FTP_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/ftp"
#define XS_IPP_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/ipp"
#define XS_PJL_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/pjl"
#define XS_MMS_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/mms"
#define XS_GEA_DIR_PATH    XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/gea"
#define XS_TFTP_DIR_PATH   XS_DB_INSTALL_DIR"/xplico/pol_%d/sol_%d/tftp"

#define XS_MIME_PARSER     XS_DB_INSTALL_DIR"/xplico/script/mimedump.py"
#define XS_MIME_TO         "TO:"
#define XS_MIME_FROM       "FROM:"
#define XS_MIME_SUBJECT    "SUBJECT:"
#define XS_HTTP_URL        "http://"
#define XS_HTTP_URL_LEN    7

#define XS_URL_REL_1       "POSSIBLY_CONTAINER"
#define XS_URL_REL_2       "POSSIBLY_CONTAINED"
#define XS_URL_REL_3       "CONTAINER"
#define XS_URL_REL_4       "CONTAINED"
#define XS_URL_REL_5       "SERVICES"
#define XS_URL_REL_6       "NONE"

#define XS_QUERY_DIM           10240
#define XS_STR_DIM             1024
#define XS_STR_PATH            2048
#define XS_STR_NONE            10
#define XS_CP_BUFFER           (1024*1024)

#define XS_HOST_ID_ADD         30
typedef struct {
    int id;                  /* DB id */
    ftval ip;                /* IP address */
    enum ftype type;         /* ip type */
} host_id;


#define XS_QUERY_SOURCE_TEMPLATE     "INSERT INTO sources (sol_id, pol_id, ip, name) VALUES (%i, %i, '%s', '%s')"
#define XS_QUERY_SOURCE_SEARCH       "SELECT id FROM sources WHERE sol_id=%d and ip='%s'"
#define XS_QUERY_POP_TEMPLATE        "INSERT INTO emails (sol_id, pol_id, source_id, capture_date, data_size, flow_info, receive, username, password, sender, receivers, subject, mime_path) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 1, '%s', '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_SMTP_TEMPLATE       "INSERT INTO emails (sol_id, pol_id, source_id, capture_date, data_size, flow_info, receive, sender, receivers, subject, mime_path) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 0, '%s', '%s',  '%s', '%s')"
#define XS_QUERY_IMAP_TEMPLATE       "INSERT INTO emails (sol_id, pol_id, source_id, capture_date, data_size, flow_info, receive, username, password, sender, receivers, subject, mime_path) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 1, '%s', '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_SIP_TEMPLATE        "INSERT INTO sips (sol_id, pol_id, source_id, capture_date, flow_info, from_addr, to_addr) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s');"
#define XS_QUERY_WEB_TEMPLATE        "INSERT INTO webs (sol_id, pol_id, source_id, capture_date, flow_info, url, relation, method, response, host, content_type, rq_header, rq_body, rq_bd_size, rs_header, rs_body, rs_bd_size) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %i, '%s', '%s', %i)"
#define XS_QUERY_FTP_TEMPLATE        "INSERT INTO ftps (sol_id, pol_id, source_id, capture_date, flow_info, url, username, password, cmd_path) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_FTP_UPDATE          "UPDATE ftps SET upload_num=%s, download_num=%s WHERE id=%lu"
#define XS_QUERY_FTP_DATA_TEMPLATE   "INSERT INTO ftp_files (sol_id, pol_id, source_id, capture_date, flow_info, ftp_id, filename, file_path, file_size, dowloaded) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%lu', '%s', '%s', '%lu', '%i')"
#define XS_QUERY_PJL_TEMPLATE        "INSERT INTO pjls (sol_id, pol_id, source_id, capture_date, flow_info, url, pdf_path, pdf_size, pcl_path, pcl_size) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%lu', '%s', '%lu')"
#define XS_QUERY_MMS_TEMPLATE        "INSERT INTO mms (sol_id, pol_id, source_id, capture_date, flow_info, url, from_num, to_num, cc_num, bcc_num, contents) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%s', '%s', %i)"
#define XS_QUERY_MMS_CONT_TEMPLATE   "INSERT INTO mmscontents (sol_id, pol_id, source_id, mm_id, content_type, filename, file_path, file_size) VALUES (%i, %i, %i, %i, '%s', '%s', '%s', %lu)"
#define XS_QUERY_FEEDS_TEMPLATE      "INSERT INTO feeds (sol_id, pol_id, source_id, name, site) VALUES (%i, %i, %i, '%s', '%s')"
#define XS_QUERY_FEEDS_SEARCH        "SELECT id FROM feeds WHERE sol_id=%d and name='%s'"
#define XS_QUERY_FEEDS_XML_TEMPLATE  "INSERT INTO feed_xmls (sol_id, pol_id, source_id, feed_id, capture_date, flow_info, url, rs_header, rs_body, rs_bd_size) VALUES (%i, %i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%i')"
#define XS_QUERY_TFTP_TEMPLATE       "INSERT INTO tftps (sol_id, pol_id, source_id, capture_date, flow_info, url, cmd_path) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s')"
#define XS_QUERY_TFTP_UPDATE         "UPDATE tftps SET upload_num=%s, download_num=%s WHERE id=%lu"
#define XS_QUERY_TFTP_DATA_TEMPLATE  "INSERT INTO tftp_files (sol_id, pol_id, source_id, capture_date, flow_info, tftp_id, filename, file_path, file_size, dowloaded) VALUES (%i, %i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%lu', '%s', '%s', '%lu', '%i')"

#endif /* __LITE_H__ */
