/* none.c
 * Basic/example dispatcher module
 *
 * $Id: none.c,v 1.2 2007/09/08 07:25:06 costa Exp $
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@xplico.org>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <stdio.h>
#include <time.h>

#include "proto.h"
#include "log.h"
#include "pei.h"
#include "gearth.h"

static unsigned long geo_id; /* geo session number, in this case we have only one session */

int DispInit(void)
{
    char kml_file[256];

    geo_id = 0;
    sprintf(kml_file, "%s/geomap_%lu.kml", ProtTmpDir(), time(NULL));
    GearthNew(geo_id, kml_file);

    return 0;
}


int DispEnd(void)
{
    GearthClose(geo_id);

    return 0;
}


int DispInsPei(pei *ppei)
{    
    if (ppei != NULL) {
        PeiPrint(ppei);
        ProtStackFrmDisp(ppei->stack, TRUE);
        GearthPei(geo_id, ppei);
    }
    
    return 0;
}

